// 013 u_site_editor
// 18 apr 2003

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

// -- programme de cration de site
// -- Ce programme est dcrit dans l'article
// --   "Site_Editor" du 28 septembre 2001
// --   visible sur le site de John COLIBRI jcolibri.free.fr

(*$r+*)

unit u_site_editor;
  interface
    uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
      Dialogs, StdCtrls, ComCtrls, ExtCtrls;

    type TForm1 = class(TForm)
                    PageControl1: TPageControl;
                    Index: TTabSheet;
                    index_memo: TMemo;
                    Panel1: TPanel;
                    Menu: TTabSheet;
                    Sommaire: TButton;
                    Edito: TButton;
                    Livres: TButton;
                    Pascalissime: TButton;
                    Articles: TButton;
                    Stages: TButton;
                    menu_memo: TMemo;
                    debug: TTabSheet;
                    Memo1: TMemo;
                    Top_: TTabSheet;
                    top_memo: TMemo;
                    Panel3: TPanel;
                    load_: TButton;
                    generate_: TButton;
                    save_: TButton;
                    Frame: TTabSheet;
                    Content: TTabSheet;
                    frame_memo: TMemo;
                    content_memo: TMemo;
                    generate_save_all_: TButton;

                    procedure FormCreate(Sender: TObject);
                    procedure SommaireClick(Sender: TObject);
                    procedure load_Click(Sender: TObject);
                    procedure generate_Click(Sender: TObject);
                    procedure generate_save_all_Click(Sender: TObject);
                    procedure save_Click(Sender: TObject);
                  private
                    procedure load_html(p_name: String; p_memo: tMemo);

                    procedure generate_index;
                    procedure generate_menu;
                    procedure generate_frame;
                    procedure generate_top;
                    procedure generate_content;

                    procedure save_page(p_path, p_name: String; p_memo: tMemo);
                    procedure save_index;
                    procedure save_menu;
                    procedure save_frame;
                    procedure save_top;
                    procedure save_content;
                  public
                  end;

    var Form1: TForm1;

  implementation
    uses FileCtrl;

    {$R *.DFM}

   
    // -- debugging display

    procedure display(p_text: String);
      begin
        Form1.Memo1.Lines.Add(p_text);
      end; // display

    // -- general parameters

    const k_site_path= 'mon_site\';

          k_index_name= 'index.html';
          k_menu_name= 'menu.html';

          k_menu_color= 'FFBBFF'; // purple
          k_top_color= 'CCFFFF'; // lite blue

    var g_site_path: String= '';

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        g_site_path:= ExtractFilePath(Application.ExeName)+ k_site_path;

        if not DirectoryExists(g_site_path)
          then begin
              display('... create dir '+ g_site_path);
              ForceDirectories(g_site_path);
            end;
      end; // FormCreate

    // -- loading the HTML source into a memo

    var g_content_name: String= 'Sommaire';

    procedure TForm1.SommaireClick(Sender: TObject);
        // -- the generic event for changing the html file name
      begin
        g_content_name:= (Sender As tButton).Caption;
        Caption:= g_content_name;
      end; // SommaireClick

    procedure TForm1.load_html(p_name: String; p_memo: tMemo);
      begin
        display('');;
        if FileExists(p_name)
          then begin
              display(p_memo.Name+ ' '+ p_name);
              p_memo.Lines.LoadFromFile(p_name)
            end
          else display('*** no '+ p_name+ '<');
      end; // load_hmtl

    procedure TForm1.load_Click(Sender: TObject);
      var l_path, l_file_name, l_complete_name: String;
      begin
        if g_content_name= ''
          then Exit;

        l_path:= g_site_path+ g_content_name+ '\';

        if PageControl1.ActivePage= Index
          then begin
              display('load into index');
              l_complete_name:= g_site_path+ 'index.html';
              load_html(l_complete_name, index_memo);
            end else
        if PageControl1.ActivePage= Menu
          then begin
              display('load into menu');
              l_complete_name:= g_site_path+ 'menu.html';
              load_html(l_complete_name, menu_memo);
            end else
        if PageControl1.ActivePage= Frame
          then begin
              display('load into frame');
              l_file_name:= g_content_name+ '_frame';
              l_complete_name:= l_path+ l_file_name+ '.html';
              load_html(l_complete_name, frame_memo);
            end else
        if PageControl1.ActivePage= Top_
          then begin
              display('load into Top');
              l_file_name:= g_content_name+ '_top';
              l_complete_name:= l_path+ l_file_name+ '.html';

              load_html(l_complete_name, top_memo);
            end else
        if PageControl1.ActivePage= Content
          then begin
              display('load into content');
              l_file_name:= g_content_name;
              l_complete_name:= l_path+ l_file_name+ '.html';

              load_html(l_complete_name, content_memo);
            end
          else l_complete_name:= '??';
      end; // load_Click

    // -- generation

    procedure TForm1.generate_index;
      begin
        display('generate_index');
        with index_memo.Lines do
        begin
          Clear;
          Add('<HTML>');
          Add('  <HEAD>');
          Add('    <TITLE>John COLIBRI</TITLE>');
          Add('  </HEAD>');
          Add('  <FRAMESET COLS="20%,80%">');
          Add('    <FRAME SRC="menu.html" SCROLLING="no">');
          Add('    <FRAME SRC="sommaire\sommaire_frame.html" NAME="content">');
          Add('  </FRAMESET>');
          Add('</HTML>');
        end; // with index_memo
      end; // generate_index

    procedure TForm1.generate_menu;

      procedure add_item(p_name: String);
        var l_text: String;
        begin
          with menu_memo.Lines do
          begin
            l_text:= '<LI><A href="'
                + p_name+ '\'+ p_name+ '_frame.html" target="content">'+ p_name+ '</A><BR>';
            Add('      '+ l_text);
          end; // with menu_memo
        end; // add_item

      var l_panel_control: Integer;

      begin // generate_menu
        display('generate_menu');
        with menu_memo.Lines do
        begin
          Clear;

          Add('<HTML>');
          Add('  <HEAD>');
          Add('  </HEAD>');
          Add('  <BODY alink="red" bgcolor=#'+ k_menu_color+ '>');
          Add('  <P>John COLIBRI</P>');
          Add('  <UL>');

          with Panel1 do
            for l_panel_control:= 0 to ControlCount- 1 do
              if Controls[l_panel_control] is tButton
                then
                  with tButton(Controls[l_panel_control]) do
                    add_item(Caption);

          Add('  </UL>');
          Add('  </BODY>');
          Add('</HTML>');
        end; // with menu_memo
      end; // generate_menu

    procedure TForm1.generate_frame;
      var l_top_name, l_content_name: String;
      begin
        display('generate_frame '+ g_content_name);
        l_top_name:= g_content_name+ '_top';
        l_content_name:= g_content_name;
        // display(l_top_name);

        with frame_memo.Lines do
        begin
          Clear;
          Add('<HTML>');
          Add('  <HEAD>');
          Add('  </HEAD>');
          Add('  <FRAMESET ROWS="40,*">');
          Add('    <FRAME SRC="'+ l_top_name+ '.html" SCROLLING="no" FRAMEBORDER="0">');
          Add('    <FRAME SRC="'+ l_content_name+ '.html" FRAMEBORDER="0">');
          Add('  </FRAMESET>');
          Add('</HTML>');
        end; // with frame_memo
      end; // generate_frame

    procedure convert_and_insert_file(p_path, p_name: String; p_c_strings: tStrings;
        p_default_text: String);
      var l_strings: tStringList;
          l_complete_name: String;
          l_line: Integer;
      begin
        l_complete_name:= p_path+ 'i_'+ p_name+ '.txt';

        if FileExists(l_complete_name)
          then begin
              l_strings:= tStringList.Create;
              l_strings.LoadFromFile(l_complete_name);
              for l_line:= 0 to l_strings.Count- 1 do
                p_c_strings.Add(l_strings[l_line]);

              l_strings.Free;
            end
          else begin
              display('*** no file '+ l_complete_name+ '<');
              p_c_strings.Add(p_default_text);
            end;
      end; // convert_and_insert_file

    procedure TForm1.generate_top;
      begin 
        display('generate_top '+ g_content_name);
        with top_memo.Lines do
        begin
          Clear;

          Add('<HTML>');
          Add('  <HEAD>');
          Add('  </HEAD>');
          Add('  <BODY bgColor=#'+ k_top_color+ '>');

          convert_and_insert_file(g_site_path+ '\'+ g_content_name+ '\',
              g_content_name+ '_top', top_memo.Lines,
              '<CENTER>'+ g_content_name+ '<CENTER>');

          display('');;
          display('TOP');

          Add('  </BODY>');
          Add('</HTML>');
        end; // with top_memo
      end; // generate_top

    procedure TForm1.generate_content;
      begin
        display('generate_content '+ g_content_name);
        with content_memo.Lines do
        begin
          Clear;

          Add('<HTML>');
          Add('  <HEAD>');
          Add('  </HEAD>');
          Add('  <BODY>');

          convert_and_insert_file(g_site_path+ '\'+ g_content_name+ '\',
              g_content_name, content_memo.Lines,
              'contenu de '+ g_content_name);

          Add('  </BODY>');
          Add('</HTML>');
        end; // with content_memo
      end; // generate_content

    procedure TForm1.generate_Click(Sender: TObject);
      begin
        with PageControl1 do
          if ActivePage= Index
            then generate_index else
          if ActivePage= Menu
            then generate_menu else
          if ActivePage= Frame
            then generate_frame else
          if ActivePage= top_
            then generate_top else
          if ActivePage= Content
            then generate_content;
      end; // generate_Click

    // -- save

    procedure TForm1.save_page(p_path, p_name: String; p_memo: tMemo);
      begin
        display('save '+ p_memo.Name);
        display('  '+ p_path);
        display('  '+ p_name+ '<');

        if not DirectoryExists(p_path)
          then begin
              display('... create dir '+ p_path);
              ForceDirectories(p_path);
            end;

        p_memo.Lines.SaveToFile(p_path+ p_name);
      end; // save_page

    procedure TForm1.save_index;
      begin
        save_page(g_site_path, 'index.html', index_memo);
      end; // save_index

    procedure TForm1.save_menu;
      begin
        save_page(g_site_path, 'menu.html', menu_memo);
      end; // save_menu

    procedure TForm1.save_frame;
      begin
        save_page(g_site_path+ g_content_name+ '\', g_content_name+ '_frame.html', frame_memo);
      end; // save_frame

    procedure TForm1.save_top;
      begin
        save_page(g_site_path+ g_content_name+ '\', g_content_name+ '_top.html', top_memo);
      end; // save_top

    procedure TForm1.save_content;
      begin
        save_page(g_site_path+ g_content_name+ '\', g_content_name+ '.html', content_memo);
      end; // save_content

    procedure TForm1.save_Click(Sender: TObject);
      begin
        with PageControl1 do
          if ActivePage= Index
            then save_index else
          if ActivePage= Menu
            then save_menu else
          if ActivePage= Frame
            then save_frame else
          if ActivePage= top_
            then save_top else
          if ActivePage= Content
            then save_content;
      end; // save_Click

    // -- generate / save all

    procedure TForm1.generate_save_all_Click(Sender: TObject);

      procedure generate_and_save(p_name: String);
        begin
          display('');;

          // -- specify the directory
          g_content_name:= p_name;

          generate_frame; save_frame;
          generate_top; save_top;
          generate_content; save_content;
        end; // generate_and_save

      var l_panel_control: Integer;

      begin // generate_save_all_Click
        display('');;
        display('Generate and save');

        display('');;
        generate_index; save_index;

        display('');;
        generate_menu; save_menu;

        with Panel1 do
          for l_panel_control:= 0 to ControlCount- 1 do
            if Controls[l_panel_control] is tButton
              then
                with tButton(Controls[l_panel_control]) do
                  generate_and_save(Caption);
      end; // generate_save_all_Click

   end.


